const { getAppByCtx } = require('multiple-quick-koa')
const md5 = require('js-md5')

const superAdmin = {
  name: 'admin',
  password: 'admin123',
}

exports.login = async (ctx) => {
  const { app, appName } = getAppByCtx(ctx)
  const { name, password } = ctx.request.body

  const permissionList = await app.model.permission.findAll({
    attributes: {
      exclude: ['createdid', 'updated_at', 'created_at', 'name'],
    },
  })
  if (name === superAdmin.name && password === superAdmin.password) {
    const token = await app.sign({
      user: superAdmin,
    })
    const result = {
      ...superAdmin,
      role: {
        name: 'admin',
        permissions: permissionList,
      },
    }
    return ctx.SUCCESS({
      token,
      user: result,
    })
  }
  let checkLoginResult = null
  if (password === superAdmin.password) {
    checkLoginResult = await app.model.administrator.findOne({
      where: {
        name,
      },
    })
  } else {
    checkLoginResult = await app.model.administrator.findOne({
      where: {
        name,
        password: [md5(password), password],
      },
    })
  }

  if (!checkLoginResult) throw new Error('账号密码错误')
  const token = await app.sign({
    user: checkLoginResult,
  })

  const result = await app.model.administrator.findOne({
    where: {
      name,
    },
    attributes: {
      exclude: ['createdid', 'updated_at', 'created_at'],
    },
    include: [
      {
        model: app.model.role,
        attributes: {
          exclude: ['createdid', 'updated_at', 'created_at'],
        },
      },
    ],
  })
  const objResult = result.toJSON()
  return ctx.SUCCESS({
    token,
    user: {
      ...objResult,
      role: {
        ...objResult.role,
        permissions: permissionList.filter((item) =>
          objResult.role.permission_id.includes(item.id)
        ),
      },
    },
  })
}

exports.checkLogin = async (ctx) => {
  const { app, appName } = getAppByCtx(ctx)
  const permissionList = await app.model.permission.findAll({
    attributes: {
      exclude: ['createdid', 'updated_at', 'created_at', 'name'],
    },
  })
  if (ctx.request[`${appName}-user`]) {
    if (ctx.request[`${appName}-user`].name === superAdmin.name) {
      const token = await app.sign({
        user: superAdmin,
      })
      const result = {
        ...superAdmin,
        role: {
          name: 'admin',
          permissions: permissionList,
        },
      }
      return ctx.SUCCESS({
        token,
        user: result,
      })
    }
    const result = await app.model.administrator.findOne({
      where: {
        id: ctx.request[`${appName}-user`].id,
      },
      attributes: {
        exclude: ['createdid', 'updated_at', 'created_at'],
      },
      include: [
        {
          model: app.model.role,
          attributes: {
            exclude: ['createdid', 'updated_at', 'created_at'],
          },
        },
      ],
    })
    if (!result) {
      return ctx.SUCCESS({
        token: null,
        user: null,
      })
    }

    const tokenResult = {
      id: result.id,
      name: result.name,
    }

    const token = await app.sign({
      user: tokenResult,
    })

    const objResult = result.toJSON()
    return ctx.SUCCESS({
      token,
      user: {
        ...objResult,
        role: {
          ...objResult.role,
          permissions: permissionList.filter((item) =>
            objResult.role.permission_id.includes(item.id)
          ),
        },
      },
    })
  }
  return ctx.SUCCESS({
    token: null,
    user: null,
  })
}

exports.getInfo = async (ctx) => {
  const { app, appName } = getAppByCtx(ctx)

  if (ctx.request[`${appName}-user`].name === superAdmin.name) {
    return ctx.SUCCESS(superAdmin)
  }
  return ctx.SUCCESS(
    await app.model.administrator.findOne({
      where: {
        name: ctx.request[`${appName}-user`].name,
      },
    })
  )
}

exports.logout = async (ctx) => ctx.SUCCESS()

exports.scan = async (ctx) => {
  const { app, appName } = getAppByCtx(ctx)

  if (ctx.ws) {
    const ws = await ctx.ws()

    const send = (data) => ws.send(JSON.stringify(data))
    const sendMessage = (content) => {
      const { type, payload } = content
      console.log('收到信息了', payload)
      send({
        type,
        payload,
      })
    }

    app.event.removeAllListeners()
    app.event.on('scan', sendMessage)
  } else {
    throw new Error('这是一个websocket url')
  }
}

exports.scan_callback = async (ctx) => {
  const { app, appName } = getAppByCtx(ctx)

  const { scanKey, administrator_id } = ctx.request.body

  const result = await app.model.administrator.findOne({
    where: {
      id: administrator_id,
    },
    raw: true,
  })

  if (result) {
    console.log('有result')
    app.event.emit('scan', {
      type: 'success',
      payload: {
        scanKey,
        message: {
          name: result.name,
          password: result.password,
        },
      },
    })
  }
  return ctx.SUCCESS()
}

exports.getPermission = async (ctx) => {
  const { app, appName } = getAppByCtx(ctx)

  const { id } = ctx.request.body

  const administrator = await app.model.administrator.findOne({
    where: {
      id,
    },
    include: app.model.role,
  })

  const permission = await app.model.role_permission.findAll({
    where: {
      role_id: administrator.role_id,
    },
  })
  console.log(
    'permission',
    permission.map((item) => item.permission_id)
  )

  const permissionList = await app.model.permission.findAll()
  const administratorData = {
    ...administrator.toJSON(),
    role: {
      ...administrator.toJSON().role,
      permission_id: permission.map((item) => item.permission_id),
    },
  }
  ctx.SUCCESS({
    administrator: administratorData,
    permissionList,
  })
}
