const { Sequelize, Random } = require('multiple-quick-koa');
const md5 = require('js-md5');

exports.name = {
  type: Sequelize.STRING,
  comment: '名字',
  allowNull: false,
  is_mock: true,
  defaultValue: '',
  sortOrder: 1,
  mock: () => Random.cword(5),
};

exports.password = {
  type: Sequelize.STRING,
  comment: '密码',
  allowNull: false,
  is_mock: false,
  defaultValue: '',
  sortOrder: 2,
  set: function (value) {
    this.setDataValue('password', md5(value))
  },
};

exports.role_id = {
  type: Sequelize.MEDIUMINT.UNSIGNED,
  comment: '角色',
  allowNull: false,
  is_mock: false,
  defaultValue: 0,
  sortOrder: 3,
  
};

exports.query = {
  type: Sequelize.JSON,
  comment: '查询条件',
  allowNull: false,
  is_mock: false,
  defaultValue: {},
  sortOrder: 4,
};


exports.post = {
  type: Sequelize.JSON,
  comment: '增改条件',
  allowNull: false,
  is_mock: false,
  defaultValue: {},
  sortOrder: 5,
};