const { Validator, getAppByCtx } = require('multiple-quick-koa')

exports.login = async (ctx) => {
  const params = {
    name: {
      type: 'string',
      required: true,
      message: '请输入用户名',
    },
    password: {
      type: 'string',
      required: true,
      message: '请输入密码',
    },
  }
  await new Validator(params).validate(ctx.request.body)
}

/**
 *
 * 详情 https://www.jianshu.com/p/2105c48b45c7
 *
 */
exports.upsert = async (ctx) => {
  const { app, appName } = getAppByCtx(ctx)
  const { id, name, password, role_id } = ctx.request.body
  if (!id && !(name && password && role_id)) {
    throw new Error('请补充完整信息')
  }
  if (role_id === 1) {
    throw new Error('只能设置一个超级管理员')
  }
}

exports.destroy = async (ctx) => {
  const { app, appName } = getAppByCtx(ctx)
  const { role_id } = ctx.request.body
  if (role_id === 1) {
    throw new Error('不能删除该平台管理员')
  }
}
