const Alipay = require('../../services/alipay')

const { getAppByCtx, getConfig } = require('multiple-quick-koa')
exports.h5_pay = async (ctx) => {
  const { app, appName } = getAppByCtx(ctx)

  const {
    name,
    order_id,
    price,
    return_url,
    prefix = '',
    type,
    out_trade_no,
  } = ctx.request.body

  const appConfig = getConfig(app)
  const { alipay_key, partner } = await appConfig.getObject('alipay')
  const { is_dev } = await appConfig.getObject('base')

  const alipay = new Alipay({
    key: alipay_key,
    partner,
    subject: name,
    out_trade_no: out_trade_no
      ? out_trade_no
      : prefix
      ? `${appName}_${prefix}-${order_id}_${type}`
      : `${appName}_${order_id}_${type}`,
    total_fee: is_dev ? 0.01 : price,
    notify_url: `https://api.kuashou.com/${appName}/alipay/notify`,
    return_url,
  })
  const url = await alipay.create()
  ctx.SUCCESS(url)
}

exports.notify = async (ctx) => {
  const { app, appName } = getAppByCtx(ctx)

  const { trade_status, out_trade_no, total_fee } = ctx.request.body
  let prefix = ''
  let order_id = out_trade_no.split('_')[1]

  const order_price = Number(total_fee)
  if (order_id.includes('-')) {
    const arr = order_id.split('-')
    order_id = Number(arr[1])
    ;[prefix] = arr
  } else {
    order_id = Number(order_id)
  }
  const model = prefix ? `${prefix}_order` : 'order'

  if (trade_status == 'TRADE_SUCCESS') {
    console.log(order_id, '支付宝支付回调-----')
    if (app.service[model] && app.service[model].notify) {
      await app.service[model].notify({
        app,
        order_id,
        order: model,
        order_price,
      })
    }
    ctx.status = 200
    ctx.body = 'success'
  }
}
