exports.init = async ({ app, appName }) => {
  const cacheModel = app.appConfig.cacheModel

  const promiseFn = async (model) => {
    const result = await app.model[model].findAll({
      include: app.include[model],
      ...(app.config[model] ? app.config[model].autoData : {}),
    })
    app.cache.set(model, JSON.parse(JSON.stringify(result)))
  }
  await Promise.all(
    cacheModel.map((model) => {
      return promiseFn(model)
    })
  )
}
