const { Validator } = require('multiple-quick-koa');

exports.email = async (ctx) => {
  const params = {
    to: {
      type: 'string',
      required: true,
      message: '请输入接收邮箱',
    },
    subject: {
      type: 'string',
      required: true,
      message: '请输入邮件主题',
    },
  };
  await new Validator(params).validate(ctx.request.body);
};

exports.sendMessage = async ctx => {
  const params = {
    mobile: {
      type: 'string',
      required: true,
      validator: (rule, value) => {
        return /^[1][1,2,3,4,5,7,8,9][0-9]{9}$/.test(value) ? Promise.resolve() : Promise.reject('请输入正确手机号');
      }
    },
  };
  await new Validator(params).validate(ctx.request.body);
}


exports.schedule = async (ctx) => {
  const params = {
    to: {
      type: 'string',
      required: true,
      message: '请输入接收邮箱',
    },
    subject: {
      type: 'string',
      required: true,
      message: '请输入邮件主题',
    },
  };
  await new Validator(params).validate(ctx.request.body);
};