const { getAppByCtx, lodash } = require('multiple-quick-koa')

exports.update = async (ctx) => {
  const { app } = getAppByCtx(ctx)

  const {
    skuList,
    good_id,
    useAttributeList,
    skuModelList,
    forceUpdate = false,
  } = ctx.request.body

  if (forceUpdate) {
    await app.model.good_attribute.destroy({
      where: {
        good_id,
      },
    })
  }

  const updateAttributeList = []
  for (let i = 0; i < useAttributeList.length; i++) {
    const { id: _id, ...rest } = useAttributeList[i]
    if (forceUpdate) {
      const { id, name, attribute_id } = await app.model.good_attribute.create({
        ...rest,
        good_id,
      })
      updateAttributeList.push({
        id,
        attribute_id,
        name,
      })
    } else {
      updateAttributeList.push(useAttributeList[i])
    }
  }
  /**
   * 会删除所有sku，所以必须在bulkCreate的时候带上
   */
  await app.model.good_sku.destroy({
    where: {
      good_id,
    },
  })
  const skuListData = skuList.map((item) => {
    const { attribute_id, good_attribute_id, ...rest } = item
    const _attribute_id = Object.entries(rest)
      .filter(([key, value]) => {
        return updateAttributeList.find((use) => use.name === value)
      })
      .map(([key, value]) => {
        return updateAttributeList.find((use) => use.name === value).id
      })
    if (!forceUpdate) {
      return {
        ...rest,
        good_attribute_id: Array.isArray(good_attribute_id)
          ? good_attribute_id
          : [good_attribute_id],
        id: rest.id,
        good_id,
      }
    } else {
      const { id, ...restNew } = rest
      return {
        ...restNew,
        good_id,
        good_attribute_id: lodash.uniq(_attribute_id),
      }
    }
  })

  await app.model.good_sku.bulkCreate(skuListData, {
    updateOnDuplicate: skuModelList.map((item) => item.key),
  })

  ctx.SUCCESS('result')
}
