const { Sequelize, Random } = require('multiple-quick-koa')

exports.openid = {
  type: Sequelize.STRING,
  comment: 'openid',
  allowNull: false,
  is_mock: false,
  defaultValue: '',
  sortOrder: 1,
  unique: true,
}

exports.user_id = {
  type: Sequelize.MEDIUMINT.UNSIGNED,
  comment: '用户',
  allowNull: false,
  is_mock: false,
  defaultValue: 0,
  sortOrder: 2,
  hasOne: true,
}

exports.nick_name = {
  type: Sequelize.STRING,
  comment: '昵称',
  allowNull: false,
  is_mock: false,
  defaultValue: '',
  sortOrder: 3,
}

exports.avatar = {
  type: Sequelize.STRING(1000),
  comment: '头像',
  allowNull: false,
  is_mock: false,
  defaultValue: '',
  sortOrder: 8,
}

exports.name = {
  type: Sequelize.VIRTUAL,
  comment: '名字',
  allowNull: false,
  is_mock: false,
  defaultValue: '',
  sortOrder: 9,
  get: function () {
    return this.getDataValue('nick_name')
  },
}

exports.appid = {
  type: Sequelize.STRING,
  comment: 'APP_ID',
  allowNull: false,
  is_mock: true,
  defaultValue: '',
  sortOrder: 10,
  mock: () => Random.ctitle(),
}

exports.unionid = {
  type: Sequelize.STRING,
  comment: 'unionid',
  allowNull: false,
  is_mock: true,
  defaultValue: '',
  sortOrder: 11,
  mock: () => Random.ctitle(),
}
