const { getAppByCtx } = require('multiple-quick-koa')

exports.clearWeixin = async (ctx) => {
  const { app } = getAppByCtx(ctx)
  const count = await app.model.log.count()
  const limit = 50000
  const page = count / limit
  let result = []
  for (let i = 0; i < page; i++) {
    const data = await app.model.log.findAll({
      attributes: ['id', 'header', 'url'],
      limit,
      offset: i * limit,
    })

    const list = data.filter(
      (item) =>
        JSON.stringify(item.header).includes('TST(Tencent Security Team)') ||
        ['/pages/', 'http'].every((h) => !item.url.startsWith(h)) ||
        [('_', ';')].some((sym) => item.url.startsWith(sym))
    )
    result = [...result, ...list.map((item) => item.id)]
  }
  ctx.SUCCESS(
    result.map((id) => {
      return {
        id,
      }
    })
  )
}
