const { Sequelize } = require('multiple-quick-koa')

exports.url = {
  type: Sequelize.STRING,
  comment: 'url',
  allowNull: false,
  defaultValue: '',
  validate: {
    notNull: {
      msg: 'url不允许为空',
    },
    notEmpty: {
      msg: 'url不允许为空',
    },
  },
  extra: {
    tableWidth: 300,
  },
}

exports.header = {
  type: Sequelize.JSON,
  comment: 'Header',
  allowNull: false,
  defaultValue: {},
}

exports.body = {
  type: Sequelize.JSON,
  comment: '参数',
  allowNull: false,
  defaultValue: {},
}

exports.message = {
  type: Sequelize.STRING,
  allowNull: false,
  comment: '错误信息',
  defaultValue: '',
  extra: {
    limit: 50,
    tableWidth: 300,
  },
}

exports.content = {
  type: Sequelize.TEXT,
  comment: '错误栈',
  allowNull: false,
  defaultValue: '',
}
