const { getAppByCtx, lodash } = require('multiple-quick-koa')

const fs = require('fs')
const path = require('path')

exports.getModel = async (ctx) => {
  const { app, appName } = getAppByCtx(ctx)

  const { model, option = 'config' } = ctx.request.body

  const pluginPath = `${process.cwd()}/app/${appName}/plugins/${model}`
  const existDir = fs.existsSync(path.resolve(__dirname, pluginPath))
  if (!existDir) return ctx.SUCCESS('')

  const existFile = fs.existsSync(
    path.resolve(
      __dirname,
      `${process.cwd()}/app/${appName}/plugins/${model}/${option}.js`
    )
  )
  if (!existFile) return ctx.SUCCESS('')
  const file = fs.readFileSync(
    path.resolve(
      __dirname,
      `${process.cwd()}/app/${appName}/plugins/${model}/${option}.js`
    ),
    'utf-8'
  )
  return ctx.SUCCESS(file)
}

exports.loadModel = async (ctx) => {
  const { app, appName } = getAppByCtx(ctx)
  await app.service.model.loadModel({
    app,
    appName,
  })

  ctx.SUCCESS('ok')
}

exports.createFile = async (ctx) => {
  const { app, appName } = getAppByCtx(ctx)
  const { plugin, config, model, controller } = ctx.request.body

  const obj = {
    config,
    model,
    controller,
  }
  if (!config && !model) throw new Error('至少config和model要有')
  const pluginDirPath = path.resolve(
    __dirname,
    `${process.cwd()}/app/${appName}/plugins/${plugin}`
  )
  const exist = fs.existsSync(pluginDirPath)
  if (!exist) fs.mkdirSync(pluginDirPath)
  const list = ['config', 'model', 'controller']

  for (let i = 0; i < list.length; i++) {
    const type = list[i]
    if (!obj[type]) {
      continue
    }
    fs.writeFileSync(path.resolve(pluginDirPath, `${type}.js`), obj[type])
  }
  // fs.writeFileSync(path.resolve(pluginDirPath, 'config.js'), desc)
  ctx.SUCCESS('ok')
}
