const { Sequelize } = require('multiple-quick-koa')

exports.model = {
  type: Sequelize.STRING,
  comment: 'model',
  allowNull: false,
  defaultValue: '',
}

exports.name = {
  type: Sequelize.STRING,
  comment: '名字',
  allowNull: false,
  defaultValue: '',
}

exports.belongs = {
  type: Sequelize.STRING,
  comment: '分类',
  allowNull: false,
  defaultValue: 'setting',
}

exports.order = {
  type: Sequelize.JSON,
  comment: '允许排序',
  allowNull: false,
  defaultValue: [],
}

exports.multiple = {
  type: Sequelize.BOOLEAN,
  comment: '允许多选删除',
  allowNull: false,
  defaultValue: false,
}

exports.availableSort = {
  type: Sequelize.BOOLEAN,
  comment: '允许自定义排序',
  allowNull: false,
  defaultValue: false,
}

exports.select = {
  type: Sequelize.JSON,
  comment: '筛选',
  allowNull: false,
  defaultValue: [],
}

exports.excludes = {
  type: Sequelize.JSON,
  comment: '忽略字段',
  allowNull: false,
  defaultValue: [],
}

exports.reference = {
  type: Sequelize.JSON,
  comment: '自定义组件',
  allowNull: false,
  defaultValue: [],
}

exports.include = {
  type: Sequelize.TEXT,
  comment: '关联表',
  allowNull: false,
  defaultValue: '',
}

exports.comment = {
  type: Sequelize.JSON,
  comment: '自定义名字',
  allowNull: false,
  defaultValue: {},
}

exports.defaultOrder = {
  type: Sequelize.JSON,
  comment: '默认排序',
  allowNull: false,
  defaultValue: [],
}

exports.sortOrder = {
  type: Sequelize.INTEGER,
  comment: '菜单排序',
  allowNull: false,
  defaultValue: 1,
}

exports.personal = {
  type: Sequelize.JSON,
  comment: '自定义按钮',
  allowNull: false,
  defaultValue: {},
}

exports.limit = {
  type: Sequelize.INTEGER,
  comment: '每页数量',
  allowNull: false,
  defaultValue: 20,
}

exports.excludeAuth = {
  type: Sequelize.JSON,
  comment: '权限',
  allowNull: false,
  defaultValue: [],
}

exports.initList = {
  type: Sequelize.JSON,
  comment: '初始化model',
  allowNull: false,
  defaultValue: [],
}

exports.autoData = {
  type: Sequelize.JSON,
  comment: 'initData过滤数据',
  allowNull: false,
  defaultValue: {},
}

exports.is_split = {
  type: Sequelize.BOOLEAN,
  comment: '允许拆分sql',
  allowNull: false,
  defaultValue: false,
}

exports.show_virtual = {
  type: Sequelize.BOOLEAN,
  comment: '显示虚拟字段',
  allowNull: false,
  defaultValue: false,
}

exports.is_split_count = {
  type: Sequelize.BOOLEAN,
  comment: '拆分count',
  allowNull: false,
  defaultValue: false,
}

exports.modelQuery = {
  type: Sequelize.JSON,
  comment: '默认查询过滤',
  allowNull: false,
  defaultValue: {},
}

exports.editInline = {
  type: Sequelize.JSON,
  comment: '局部更新',
  allowNull: false,
  defaultValue: {},
}

exports.deleteCheckList = {
  type: Sequelize.JSON,
  comment: '删除检测',
  allowNull: false,
  defaultValue: [],
}
