const { Sequelize, Random } = require('multiple-quick-koa')

exports.model_id = {
  type: Sequelize.INTEGER(11),
  allowNull: false,
  defaultValue: 0,
  comment: '模型',
}

exports.name = {
  type: Sequelize.STRING,
  comment: '属性',
  allowNull: false,
  defaultValue: '',
  mock: () => Random.csentence(),
}

exports.type = {
  type: Sequelize.STRING,
  comment: '类型',
  allowNull: false,
  defaultValue: 'STRING',
}

exports.comment = {
  type: Sequelize.STRING,
  comment: '注释',
  allowNull: false,
  defaultValue: '注释',
}

exports.allowNull = {
  type: Sequelize.BOOLEAN,
  comment: '允许null',
  allowNull: false,
  defaultValue: false,
}

exports.defaultValue = {
  type: Sequelize.STRING,
  comment: '默认值',
  allowNull: false,
  defaultValue: '默认值',
}

exports.mock = {
  type: Sequelize.TEXT,
  comment: '模拟数据',
  allowNull: false,
  defaultValue: '',
}

exports.is_mock = {
  type: Sequelize.BOOLEAN,
  comment: '是否mock',
  allowNull: false,
  defaultValue: false,
}

exports.set = {
  type: Sequelize.TEXT,
  comment: 'set',
  allowNull: false,
  defaultValue: '',
}

exports.get = {
  type: Sequelize.TEXT,
  comment: 'set',
  allowNull: false,
  defaultValue: '',
}

exports.unique = {
  type: Sequelize.BOOLEAN,
  comment: '唯一值',
  allowNull: false,
  defaultValue: false,
}

exports.hasOne = {
  type: Sequelize.BOOLEAN,
  comment: '关联唯一',
  allowNull: false,
  defaultValue: false,
}

exports.validate = {
  type: Sequelize.JSON,
  comment: '验证',
  allowNull: true,
  defaultValue: {},
}

exports.sortOrder = {
  type: Sequelize.INTEGER,
  comment: '排序',
  allowNull: false,
  defaultValue: 1,
}

exports.belongsTo = {
  type: Sequelize.STRING,
  comment: '关联原型',
  allowNull: false,
  defaultValue: '',
}

exports.extra = {
  type: Sequelize.JSON,
  comment: '默认配置',
  allowNull: true,
  defaultValue: {},
}
