const { getAppByCtx } = require('multiple-quick-koa')

exports.init = async (ctx) => {
  const { app } = getAppByCtx(ctx)

  const roleList = await app.model.role.findAll({
    include: [
      {
        model: app.model.role_permission,
      },
    ],
  })

  for (let i = 0; i < roleList.length; i++) {
    const item = roleList[i].toJSON()
    const permission_id = item.role_permissions.map((item) => {
      return item.permission_id
    })
    await app.model.role.upsert({
      id: item.id,
      permission_id,
    })
  }

  ctx.SUCCESS('ok')
}
