const { Sequelize, Random } = require('multiple-quick-koa')

exports.name = {
  type: Sequelize.STRING,
  comment: '名字',
  allowNull: false,
  is_mock: false,
  defaultValue: '',
  sortOrder: 1,
}

exports.query = {
  type: Sequelize.JSON,
  comment: '查询条件',
  allowNull: false,
  is_mock: false,
  defaultValue: {},
  sortOrder: 2,
}

exports.post = {
  type: Sequelize.JSON,
  comment: '增改条件',
  allowNull: false,
  is_mock: false,
  defaultValue: {},
  sortOrder: 3,
}

exports.is_diy_router = {
  type: Sequelize.BOOLEAN,
  comment: '是否自定义路由',
  allowNull: false,
  is_mock: true,
  defaultValue: false,
  sortOrder: 4,
  mock: () => Random.boolean(),
  extra: {
    controlInline: true,
  },
}

exports.permission_id = {
  type: Sequelize.JSON,
  comment: '权限',
  allowNull: false,
  is_mock: true,
  defaultValue: [],
  sortOrder: 5,
  get: function () {
    return this.getDataValue('permission_id') === null
      ? []
      : this.getDataValue('permission_id')
  },
  extra: {
    tableWidth: 500,
  },
}
