const { Sequelize, Random } = require('multiple-quick-koa')

exports.name = {
  type: Sequelize.STRING,
  comment: '名字',
  allowNull: false,
  is_mock: true,
  defaultValue: '',
  sortOrder: 1,
  mock: () => Random.ctitle(),
}

exports.icon = {
  type: Sequelize.STRING,
  comment: '图标',
  allowNull: false,
  is_mock: true,
  defaultValue: '',
  sortOrder: 2,
  mock: () => Random.ctitle(),
}

exports.parent_id = {
  type: Sequelize.INTEGER.UNSIGNED,
  comment: '上级',
  allowNull: false,
  is_mock: true,
  defaultValue: 0,
  sortOrder: 3,
  mock: () => Random.integer(1, 3),
}

exports.url = {
  type: Sequelize.STRING,
  comment: '链接',
  allowNull: false,
  is_mock: true,
  defaultValue: '',
  sortOrder: 4,
  mock: () => Random.ctitle(),
}

exports.model_id = {
  type: Sequelize.MEDIUMINT.UNSIGNED,
  comment: '模型',
  allowNull: false,
  is_mock: true,
  defaultValue: 0,
  sortOrder: 5,
  mock: () => Random.integer(1, 5),
}

exports.sortOrder = {
  type: Sequelize.MEDIUMINT.UNSIGNED,
  comment: '排序',
  allowNull: false,
  is_mock: false,
  defaultValue: 0,
  sortOrder: 6,
}

exports.key = {
  type: Sequelize.STRING,
  comment: 'model_key',
  allowNull: false,
  is_mock: true,
  defaultValue: '',
  sortOrder: 7,
  mock: () => Random.ctitle(),
}
