exports.initRouter = async ({ app }) => {
  console.log('initRouter start')
  const routesList = await app.model.routes.findAll()
  const modelList = await app.model.model.findAll()

  const list = routesList.map((_item) => {
    const item = _item.toJSON()
    const target = modelList.find((m) => m.model === item.key.split('/')[1])
    if (target) {
      return {
        ...item,
        model_id: target.id,
      }
    } else {
      return item
    }
  })
  await app.model.routes.bulkCreate(list, {
    updateOnDuplicate: ['model_id'],
  })
  console.log('initRouter success!')
}
