const { getAppByCtx } = require('multiple-quick-koa')
const axios = require('axios')

exports.bulkUpdate = async (ctx) => {
  const { app, appName } = getAppByCtx(ctx)
  const { list } = ctx.request.body
  const result = await app.model.setting.bulkCreate(list, {
    updateOnDuplicate: ['id', 'value'],
  })
  ctx.SUCCESS(result)
}

exports.copyOther = async (ctx) => {
  const { app, appName } = getAppByCtx(ctx)

  const { type, source } = ctx.request.body

  const { data } = await axios
    .post(`http://localhost:3001/${source}/setting/findAll`)
    .then((res) => res.data)

  const copyType = data.find((item) => item.code === type)

  if (!copyType) throw new Error('克隆方找不到')

  const copyList = data.filter((item) => item.parent_id === copyType.id)

  const list = await app.model.setting.findAll()

  const findType = list.find((item) => item.code === type)
  if (!findType) throw new Error('自己找不到')

  await app.model.setting.destroy({
    where: {
      parent_id: findType.id,
    },
  })

  await app.model.setting.bulkCreate(
    copyList.map((item) => {
      const { parent, id, ...rest } = item
      return {
        ...rest,
        parent_id: findType.id,
      }
    })
  )

  ctx.SUCCESS('ok')
}
