const { Validator,getAppByCtx } = require('multiple-quick-koa');


exports.bulkUpdate = async (ctx) => {
  const params = {
    list: {
      type: 'array',
      required: true,
      message: '请输入list',
    },
  };
  await new Validator(params).validate(ctx.request.body);
};

exports.upsert = async ctx => {
  const {
    app
  } = getAppByCtx(ctx);

  const {
    id,
    parent_id
  } = ctx.request.body

  if (id && parent_id && id === parent_id) throw new Error('不能分类到自己')
};

exports.copyOther = async (ctx) => {
  const params = {
    type: {
      type: 'string',
      required: true,
      message: '请输入type, 需要复制哪个code',
    },
    source:{
      type: 'string',
      required: true,
      message: '请输入source, 需要从哪个项目复制哪个（记得开启)',
    }
  };
  await new Validator(params).validate(ctx.request.body);
};