const { Validator, getAppByCtx } = require('multiple-quick-koa');

exports.initModel = async (ctx) => {
  const params = {
    model: {
      type: 'string',
      required: true,
      message: '请输入model',
    },
  };
  await new Validator(params).validate(ctx.request.body);
};

exports.showAllSchemas = async (ctx) => {
  const {app,appName} = getAppByCtx(ctx)

  const params = {
    model: {
      type: 'string',
      required: true,
      message: '请输入model',
      validator: (rule, value) => ((app[appName].model && app[appName].model[value]) ? Promise.resolve() : Promise.reject('没有这个模型')),
    },
  };
  await new Validator(params).validate(ctx.request.body);
};

exports.dropModel = async (ctx) => {
  const {app,appName} = getAppByCtx(ctx)

  const params = {
    model: {
      type: 'string',
      required: true,
      message: '请输入model',
      validator: (rule, value) => ((app[appName].model && app[appName].model[value]) ? Promise.resolve() : Promise.reject('没有这个模型')),
    },
  };
  await new Validator(params).validate(ctx.request.body);
};
