const { Sequelize, Random } = require('multiple-quick-koa')

exports.name = {
  type: Sequelize.STRING,
  comment: '简介',
  allowNull: false,
  is_mock: true,
  defaultValue: '',
  sortOrder: 1,
  mock: () => Random.ctitle(),
}

exports.desc = {
  type: Sequelize.TEXT,
  comment: '详细描述',
  allowNull: false,
  is_mock: true,
  defaultValue: '',
  sortOrder: 2,
  mock: () => Random.csentence(),
}

exports.image_list = {
  type: Sequelize.JSON,
  comment: '相关图片',
  allowNull: false,
  is_mock: true,
  defaultValue: [],
  sortOrder: 3,
  mock: () =>
    Random.range(5).map((item, index) =>
      Random.image('200x200', Random.color(), Random.cword())
    ),
  extra: {
    tableWidth: 0,
  },
}

exports.status = {
  type: Sequelize.ENUM('待定', '待完成', '已完成'),
  comment: '状态',
  allowNull: false,
  is_mock: true,
  defaultValue: '待定',
  sortOrder: 4,
  mock: () => ['待定', '待完成', '已完成'][Random.integer(0, 2)],
}

exports.type = {
  type: Sequelize.ENUM('需求', 'bug'),
  comment: '类型',
  allowNull: false,
  is_mock: true,
  defaultValue: '需求',
  sortOrder: 5,
  mock: () => ['需求', 'bug'][Random.integer(0, 1)],
}

exports.important_rate = {
  type: Sequelize.TINYINT,
  comment: '重要级',
  allowNull: false,
  is_mock: false,
  defaultValue: 0,
  sortOrder: 6,
  extra: {
    tableWidth: 180,
  },
}
