const { Sequelize } = require('multiple-quick-koa')

exports.openid = {
  type: Sequelize.STRING,
  comment: 'openid',
  allowNull: false,
  unique: true,
}

exports.nick_name = {
  type: Sequelize.STRING,
  comment: '昵称',
  allowNull: false,
  defaultValue: '',
}

exports.gender = {
  type: Sequelize.INTEGER(11),
  allowNull: false,
  defaultValue: 1,
  comment: '性别',
}

exports.city = {
  type: Sequelize.STRING,
  comment: '城市',
  allowNull: false,
  defaultValue: '',
}

exports.province = {
  type: Sequelize.STRING,
  comment: '省份',
  allowNull: false,
  defaultValue: '',
}

exports.country = {
  type: Sequelize.STRING,
  comment: '国家',
  allowNull: false,
  defaultValue: '',
}

exports.avatar = {
  type: Sequelize.STRING(1000),
  comment: '头像',
  allowNull: false,
  defaultValue: '',
}

exports.name = {
  type: Sequelize.VIRTUAL,
  comment: '名字',
  get: function () {
    return this.getDataValue('nick_name')
  },
}

exports.user_id = {
  type: Sequelize.INTEGER(11),
  allowNull: false,
  defaultValue: 0,
  comment: '用户',
  hasOne: true,
}
