const { Sequelize, Random } = require('multiple-quick-koa');
const md5 = require('js-md5');

exports.nick_name = {
  type: Sequelize.STRING,
  comment: '昵称',
  allowNull: false,
  is_mock: false,
  defaultValue: '',
  sortOrder: 1,
};
exports.name = {
  type: Sequelize.STRING,
  comment: '名字',
  allowNull: false,
  is_mock: true,
  defaultValue: '',
  sortOrder: 2,
  mock: () => Random.word(5),
  get: function () {
    return this.getDataValue('nick_name') || (this.getDataValue('mp_user') && this.getDataValue('mp_user').nick_name) ||
    (this.getDataValue('h5_user') && this.getDataValue('h5_user').nick_name) ||
    (this.getDataValue('toutiao_user') && this.getDataValue('toutiao_user').nick_name) ||
    '匿名用户'
  },
};

exports.image = {
  type: Sequelize.VIRTUAL,
  comment: '注释',
  allowNull: false,
  is_mock: false,
  defaultValue: '',
  sortOrder: 3,
  get: function () {
    return this.getDataValue('avatar') || (this.getDataValue('mp_user') && this.getDataValue('mp_user').avatar) ||
      (this.getDataValue('h5_user') && this.getDataValue('h5_user').avatar) ||
      (this.getDataValue('toutiao_user') && this.getDataValue('toutiao_user').avatar) ||
      '//p0.meituan.net/codeman/bc1b8f0172cf718719edfb130ba171912425.jpg@120w_120h_1c_1e'
  },
};

exports.avatar = {
  type: Sequelize.STRING,
  comment: '头像',
  allowNull: false,
  defaultValue: '//p0.meituan.net/codeman/bc1b8f0172cf718719edfb130ba171912425.jpg@120w_120h_1c_1e',
  mock: () => Random.image('100x100', Random.color(), Random.cword()),
};

exports.code = {
  type: Sequelize.STRING(6),
  allowNull: false,
  comment: '验证码',
  defaultValue: '',
  mock: () => Random.string('number', 4),
};

exports.sex_id = {
  type: Sequelize.INTEGER(11),
  allowNull: false,
  defaultValue: 4,
  comment: '性别',
};

exports.password = {
  type: Sequelize.STRING(),
  allowNull: false,
  comment: '密码',
  defaultValue: '7b17d87eb787c51b4da25ec1bed26c8d',
  set(value) {
    this.setDataValue('password', md5(value))
  }
  // validate: {
  //   notNull: {
  //     msg: '密码不允许为空',
  //   },
  //   notEmpty: {
  //     msg: '密码不允许为空',
  //   },
  // },
};

exports.mobile = {
  type: Sequelize.STRING(),
  allowNull: false,
  comment: '手机',
  defaultValue: '',
  // validate: {
  //   is: {
  //     args: /^1[3456789]\d{9}$/,
  //     msg: '请输入手机号',
  //   },
  // },
  mock: () => Random.natural(13000000000, 19999999999),
};