const { Validator } = require('multiple-quick-koa');

exports.getConfig = async (ctx) => {
  const params = {
    url: {
      type: 'string',
      required: true,
      message: '请输入url',
    },
  };
  await new Validator(params).validate(ctx.request.body);
};

exports.h5_pay = async (ctx) => {
  /**
   * 判断微信
   */
  const userAgent = ctx.userAgent._agent.source;
  const isWeixin = /MicroMessenger/i.test(userAgent);
  if (isWeixin) throw new Error('请用手机浏览器打开');
};

exports.wx_pay = async (ctx) => {
  /**
   * 判断微信
   */
  const userAgent = ctx.userAgent._agent.source;
  const isWeixin = /MicroMessenger/i.test(userAgent);
  if (!isWeixin) throw new Error('请在微信里打开');
};

exports.pay = async (ctx) => {
  const params = {
    body: {
      type: 'string',
      required: true,
      message: '请输入支付标题',
    },
    out_trade_no: {
      type: 'string',
      required: true,
      message: '请输入订单号',
    },
    total_fee: {
      type: 'number',
      required: 1,
      message: '请输入支付金额',
    },
  };
  await new Validator(params).validate(ctx.request.body);
};

exports.mp_login = async (ctx) => {
  const params = {
    code: {
      type: 'string',
      required: true,
      message: '需要code登录',
    },
  };
  await new Validator(params).validate(ctx.request.body);
};


exports.qr_code = async (ctx) => {
  const params = {
    page: {
      type: 'string',
      required: true,
      message: '请输入页面链接：pages/index/index',
    },
    is_hyaline: {
      type: 'boolean',
      required: false,
      message: 'is_hyaline 是否透明 boolean',
    },
    scene: {
      type: 'object',
      required: false,
      message: 'scene 参数 object',
    },
  };
  await new Validator(params).validate(ctx.request.body);
};


exports.sendMessage = async (ctx) => {
  const params = {
    template_id: {
      type: 'string',
      required: true,
      message: '请输入模版｜qyq3BJ4sMhOiBwJOjR3iTiyk8fX0vmC_R7d2PnHySks',
    },
    openid: {
      type: 'string',
      required: true,
      message: 'openid | oETg_5eggr_QA8bBzcEZ_A31ZRkk',
    },
    data: {
      type: 'object',
      required: true,
      message: 'data | {name1:{value:\'苏晓光\'},number2:{value:\'32323\'},thing5:{value:\'xxx\'}}',
    },
    page: {
      type: 'string',
      required: false,
      message: '请输入页面链接：pages/index/index',
    },
  };
  await new Validator(params).validate(ctx.request.body);
};
