const Core = require('@alicloud/pop-core');
const {
  lodash
} = require('multiple-quick-koa')
module.exports = class Sms {
  constructor (config) {
    this.config = {
      accessKeyId: config.accessKeyId, // 开发者账号id
      accessKeySecret: config.accessKeySecret, // 开发者token
      SignName: config.SignName, // 应用id
      param: Array.from({
        length: config.number || 4
      }, () => lodash.random(0, 9)).join(''),
    };
    this.client = new Core({
      accessKeyId: this.config.accessKeyId,
      accessKeySecret: this.config.accessKeySecret,
      endpoint: 'https://dysmsapi.aliyuncs.com',
      apiVersion: '2017-05-25'
    });
  }

  async send ({
    mobile,
    TemplateCode,
    TemplateParam
  }) {
    // if(!mobile) throw new Error('请输入手机号码')
    const result = await this.client.request('SendSms', {
      PhoneNumbers: mobile,
      SignName: this.config.SignName,
      TemplateCode,
      TemplateParam: JSON.stringify({
        code: this.config.param
      })
    }, {
      method: 'POST'
    })
    return result
  }

  getCode () {
    return this.config.param
  }
};