const crypto = require('crypto')
const { lodash } = require('multiple-quick-koa')
module.exports = class Singleton {
  constructor(config) {
    this.config = {
      service: 'alipay.wap.create.direct.pay.by.user',
      partner: '',
      _input_charset: 'utf-8',
      sign_type: 'MD5',
      key: '',
      out_trade_no: '9890879868657',
      subject: '商品',
      total_fee: '',
      seller_id: '',
      payment_type: '1',
      show_url: 'https://www.kuashou.com',
      notify_url:
        'http://www.test.com/create_direct_pay_by_user-JAVA-UTF-8/notify_url.jsp',
      return_url: 'http://www.baidu.com',
      ...config,
    }
    /**
     * 单例模式
     */
    if (!Singleton.instance) {
      Singleton.instance = this
    }
    const previous = Singleton.instance.getConfig()
    if (!lodash.isEqual(previous, config)) {
      Singleton.instance = this
    }
    return Singleton.instance
  }

  async create() {
    const paraFilterResult = this.paraFilter(this.config)
    const paraSort = this.argSort(paraFilterResult)
    const prestr = this.createLinkstring(paraSort)
    const sign = this.md5Sign(prestr, this.config.key)
    const { key, ...rest } = this.config
    const postData = {
      ...rest,
      sign,
    }

    const url = require('url').format({
      protocol: 'https',
      hostname: 'mapi.alipay.com',
      pathname: '/gateway.do',
      query: {
        ...postData,
      },
    })

    return url
  }

  // async getConfig() {
  //   const config = (await system.findOne({
  //     raw: true,
  //     where: {
  //       code: 'alipay',
  //     },
  //   })).value;

  //   const partner = getSetting(config)('partner');
  //   const alipay_key = getSetting(config)('alipay_key');
  //   const total_fee = getSetting(config)('total_fee');
  //   this.config = {
  //     ...this.config,
  //     partner,
  //     key: alipay_key,
  //     total_fee,
  //     seller_id: partner,
  //   };
  // }

  paraFilter(para) {
    const para_filter = new Object()
    for (const key in para) {
      if (
        key == 'sign' ||
        key == 'sign_type' ||
        para[key] == '' ||
        key == 'key'
      ) {
        continue
      } else {
        para_filter[key] = para[key]
      }
    }

    return para_filter
  }

  argSort(para) {
    const result = new Object()
    const keys = Object.keys(para).sort()
    for (let i = 0; i < keys.length; i++) {
      const k = keys[i]
      result[k] = para[k]
    }
    return result
  }

  createLinkstring(para) {
    let ls = ''
    for (const k in para) {
      ls = `${ls + k}=${para[k]}&`
    }
    ls = ls.substring(0, ls.length - 1)
    return ls
  }

  md5Sign(prestr, key) {
    prestr += key
    return crypto.createHash('md5').update(prestr, 'utf8').digest('hex') // crypto.createHash('md5').update(prestr).digest("hex");
  }

  getConfig() {
    return this.config
  }
}
