const axios = require('axios')
const { lodash } = require('multiple-quick-koa')
const send_url = 'http://wuliu.market.alicloudapi.com/kdi'
module.exports = class Singleton {
  constructor (config) {
    this.config = {
      app_code: config.app_code,
    }

    /**
     * 单例模式
     */
    if (!Singleton.instance) {
      Singleton.instance = this
    }
    const previous = Singleton.instance.getConfig()
    if (!lodash.isEqual(previous, config)) {
      Singleton.instance = this
    }
    return Singleton.instance
  }

  async send ({ no }) {
    const result = await axios({
      method: 'GET',
      url: `${send_url}?no=${no}`,
      headers: {
        Authorization: `APPCODE ${this.config.app_code}`,
      },
    }).then((res) => res.data)
    return result.result
  }

  getConfig () {
    return this.config
  }
}
