const axios = require('axios')
const parseString = require('xml2js').parseString

const baseUrl = 'https://h5vv.video.qq.com/getinfo?'

const parseXML = (data) => {
  return new Promise((resolve, reject) => {
    parseString(
      data.data,
      {
        explicitArray: false,
      },
      function (err, result) {
        if (err) reject(err)
        resolve(result)
      }
    )
  })
}

const fetchVideo = (vid) => {
  let params = {
    otype: 'xml',
    guid: 'b9a639401758a1a2b205bb1c41aaa01d',
    platform: '11001',
    host: 'm.v.qq.com',
    sphttps: '1',
    vid: vid,
  }
  let paramsArr = [].concat(baseUrl)
  for (var key in params) {
    paramsArr.push('' + key + '=' + params[key])
  }
  var url = paramsArr.join('&')
  return axios.get(url)
}

const handlebaseVideo = (result) => {
  let vl = result.root.vl
  if (!vl) throw new Error('vid不合法或不存在')
  let host = 'https://ugcbsy.qq.com/'
  let filename = vl.vi.fn
  let duration = Number(vl.vi.td)
  let fvkey = vl.vi.fvkey
  let name = vl.vi.ti
  let vid = vl.vi.lnk
  let video = `${host}${filename}?vkey=${fvkey}`
  let image = `https://puui.qpic.cn/qqvideo_ori/0/${vid}_496_280/0`
  // let img = `https://ypy.kuashou.org/tennis/qqvideo/${vid}.jpg`
  return {
    video,
    image,
    name,
    vid,
    duration,
    from: 'qq',
  }
}

module.exports = async function (vid) {
  let baseData = await fetchVideo(vid)
  let baseResult = await parseXML(baseData)
  return handlebaseVideo(baseResult)
}
