const path = require('path')
const fs = require('fs')
const {
  WapPay,
  PubPay,
  RequestError,
  CommunicationError,
  utils: { getXMLBody },
} = require('@sigodenjs/wechatpay')

module.exports = class WeixinPay {
  constructor(config) {
    this.pay = new WapPay({
      appId: config.appId,
      key: config.key,
      mchId: config.mchId,
      pfx: null,
    })
  }

  async run(options) {
    const config = {
      spbill_create_ip: '8.8.8.8',
      ...options,
    }
    return await this.pay.unifiedOrder(config)
  }

  async getXMLBody(data) {
    return await getXMLBody(data, {
      limit: '1mb',
      encoding: 'utf8',
    })
  }
}
