
const { parseString, Builder } = require('xml2js')

const xmlToJson = (str) => {
  return new Promise((resolve, reject) => {
    parseString(str, (err, result) => {
      if (err) {
        reject(err)
      } else {
        resolve(result)
      }
    })
  })
}
exports.xmlToJson = xmlToJson

exports.jsonToXml = (obj) => {
  const builder = new Builder()
  return builder.buildObject(obj)
}

exports.xmlPromise = ctx => new Promise(function (resolve, reject) {
  let buf = ''
  ctx.req.setEncoding('utf8')
  ctx.req.on('data', (chunk) => {
    buf += chunk
  })
  ctx.req.on('end', () => {
    xmlToJson(buf)
      .then(resolve)
      .catch(reject)
  })
})