const fsExtra = require('fs-extra');
const path = require('path');
const _ = require('lodash');

const filterNoNeed = item => _.omit(item, ['created_at', 'updated_at']);
exports.payType = async (app) => {
  const list = [
    {
      name: '微信',
      key: 'weixin',
      image: '/upload/562e45760a44632de6fa7219bab78cce.png',
      id: 1,
    },
    {
      name: '支付宝',
      key: 'alipay',
      image: '/upload/d7aeaeb6bfd68f71a00a83c0f5548363.png',
      id: 2,
    },
    {
      name: '余额支付',
      key: 'balance',
      image: '',
      id: 3,
    }];
  for (let i = 0; i < list.length; i++) {
    await app.model.pay_type.upsert(list[i]);
  }

  return true;
};

exports.setting = async (app) => {
  const list = [
    {
      name: '基础设置',
      code: 'base',
      type: 'input',
      value: '',
      parent_id: 0,
      id: 1,
      created_at: '2019-10-04T14:18:48.000Z',
      updated_at: '2019-10-04T14:18:48.000Z',
    },
    {
      name: '网站名',
      code: 'site_name',
      type: 'input',
      value: '京东商城',
      parent_id: 1,
      id: 2,
      created_at: '2019-10-04T14:19:09.000Z',
      updated_at: '2019-10-04T14:19:09.000Z',
    },
    {
      name: '语言包',
      code: 'lang',
      type: 'input',
      value: '',
      parent_id: 0,
      id: 3,
      created_at: '2019-10-04T14:42:01.000Z',
      updated_at: '2019-10-04T14:42:01.000Z',
    },
    {
      name: '版权说明',
      code: 'copyright',
      type: 'input',
      value: '@copyright by 苏晓光',
      parent_id: 3,
      id: 4,
      created_at: '2019-10-04T14:42:48.000Z',
      updated_at: '2019-10-04T14:42:48.000Z',
    },
    {
      name: '域名',
      code: 'site_host',
      type: 'input',
      value: 'www.jd.com',
      parent_id: 1,
      id: 5,
      created_at: '2019-10-04T14:49:39.000Z',
      updated_at: '2019-10-04T14:49:39.000Z',
    },
    {
      name: 'Logo图片',
      code: 'logo_img',
      type: 'image',
      value: 'https://misc.360buyimg.com/jdf/1.0.0/unit/global-header/5.0.0/i/jdlogo-201708-@1x.png',
      parent_id: 1,
      id: 6,
      created_at: '2019-10-04T14:54:47.000Z',
      updated_at: '2019-10-04T14:54:47.000Z',
    },
    {
      name: '短信配置',
      code: 'sms',
      type: 'input',
      value: '',
      parent_id: 0,
      id: 13,
      created_at: '2019-10-05T09:47:40.000Z',
      updated_at: '2019-10-05T09:47:40.000Z',
    },
    {
      name: '账号唯一标识',
      code: 'sid',
      type: 'input',
      value: 'e23cfbe4425fda035ac8afa77330deff',
      parent_id: 13,
      id: 14,
      created_at: '2019-10-05T09:48:02.000Z',
      updated_at: '2019-10-05T09:48:02.000Z',
    },
    {
      name: '应用ID',
      code: 'appid',
      type: 'input',
      value: 'f9b475e4f90e4e4ea2226206ebf9c449',
      parent_id: 13,
      id: 15,
      created_at: '2019-10-05T09:48:26.000Z',
      updated_at: '2019-10-05T09:48:26.000Z',
    },
    {
      name: '用户密钥',
      code: 'token',
      type: 'input',
      value: 'f3aebd9d70b05122c542cebde7315123',
      parent_id: 13,
      id: 16,
      created_at: '2019-10-05T09:48:46.000Z',
      updated_at: '2019-10-05T09:48:46.000Z',
    },
    {
      name: '模板ID',
      code: 'templateid',
      type: 'input',
      value: '500487',
      parent_id: 13,
      id: 17,
      created_at: '2019-10-05T09:49:05.000Z',
      updated_at: '2019-10-05T09:49:05.000Z',
    },
    {
      name: '小程序设置',
      code: 'weixin_mp',
      type: 'input',
      value: '',
      parent_id: 0,
      id: 18,
      created_at: '2019-11-08T12:28:22.000Z',
      updated_at: '2019-11-08T12:28:22.000Z',
    },
    {
      name: 'APP_ID',
      code: 'app_id',
      type: 'input',
      value: 'wxaa3a21a0ee590ff9',
      parent_id: 18,
      id: 19,
      created_at: '2019-11-08T12:29:07.000Z',
      updated_at: '2019-11-08T12:29:07.000Z',
    },
    {
      name: 'APP_SECRECT',
      code: 'app_secrect',
      type: 'input',
      value: '098e45c89c000ccd40437604499024a7',
      parent_id: 18,
      id: 20,
      created_at: '2019-11-08T12:29:26.000Z',
      updated_at: '2019-11-08T12:29:26.000Z',
    },
    {
      name: '微信公众号设置',
      code: 'weixin_h5',
      type: 'input',
      value: '',
      parent_id: 0,
      id: 21,
      created_at: '2019-11-09T10:36:00.000Z',
      updated_at: '2019-11-09T10:36:00.000Z',
    },
    {
      name: 'APP_ID',
      code: 'app_id',
      type: 'input',
      value: 'wxc87b24223b65d6fc',
      parent_id: 21,
      id: 22,
      created_at: '2019-11-09T10:37:19.000Z',
      updated_at: '2019-11-09T10:37:19.000Z',
    },
    {
      name: 'APP_SECRECT',
      code: 'app_secrect',
      type: 'input',
      value: '6934d56c7e772b5b99141f710495bb1e',
      parent_id: 21,
      id: 23,
      created_at: '2019-11-09T10:37:57.000Z',
      updated_at: '2019-11-09T10:37:57.000Z',
    },
    {
      name: '域名（授权用）',
      code: 'host_link',
      type: 'input',
      value: 'http://compserviceplat.shenzhenbenwo.com',
      parent_id: 21,
      id: 24,
      created_at: '2019-11-09T13:31:01.000Z',
      updated_at: '2019-11-09T13:31:01.000Z',
    },
    {
      name: '微信支付',
      code: 'weixin_pay',
      type: 'input',
      value: '',
      parent_id: 0,
      id: 25,
      created_at: '2019-11-11T16:15:36.000Z',
      updated_at: '2019-11-11T16:15:36.000Z',
    },
    {
      name: '商户号',
      code: 'mch_id',
      type: 'input',
      value: '1559499381',
      parent_id: 25,
      id: 26,
      created_at: '2019-11-11T16:16:02.000Z',
      updated_at: '2019-11-11T16:16:02.000Z',
    },
    {
      name: '密钥',
      code: 'key',
      type: 'input',
      value: 'lljjlljjlljjlljjlljjlljjlljjlljj',
      parent_id: 25,
      id: 27,
      created_at: '2019-11-11T16:16:21.000Z',
      updated_at: '2019-11-11T16:16:21.000Z',
    },
    {
      name: 'API证书',
      code: 'key',
      type: 'image',
      value: '',
      parent_id: 25,
      id: 28,
      created_at: '2019-11-11T16:23:48.000Z',
      updated_at: '2019-11-11T16:23:48.000Z',
    },
    {
      name: 'Logo图片',
      code: 'logo_img',
      type: 'file',
      value: '/upload/ab45df2d626306c933079dd7611f5c8e.psd',
      parent_id: 1,
      id: 29,
      created_at: '2019-11-12T02:24:27.000Z',
      updated_at: '2019-11-12T02:24:27.000Z',
    },
    {
      name: '快递查询',
      code: 'express',
      type: 'input',
      value: '',
      parent_id: 0,
      id: 30,
      created_at: '2019-12-13T01:05:30.000Z',
      updated_at: '2019-12-13T01:05:30.000Z',
    },
    {
      name: '分销比例',
      code: 'spread_rate',
      type: 'decimal',
      value: '0.15',
      parent_id: 32,
      id: 31,
      created_at: null,
      updated_at: null,
    },
    {
      name: '分销设置',
      code: 'spread',
      type: 'input',
      value: '',
      parent_id: 0,
      id: 32,
      created_at: null,
      updated_at: null,
    },
    {
      name: '分销开启',
      code: 'spread_avaiable',
      type: 'switch',
      value: '1',
      parent_id: 32,
      id: 33,
      created_at: null,
      updated_at: null,
    },
    {
      name: 'APP CODE',
      code: 'app_code',
      type: 'input',
      value: '59f7e9da22e84913a5414cb959cef1e4',
      parent_id: 30,
      id: 34,
      created_at: null,
      updated_at: null,
    },
    {
      name: '积分设置',
      code: 'integral',
      type: 'input',
      value: '',
      parent_id: 0,
      id: 35,
      created_at: null,
      updated_at: null,
    },
    {
      name: '赠送积分开启',
      code: 'integral_avaiable',
      type: 'switch',
      value: '1',
      parent_id: 35,
      id: 36,
      created_at: null,
      updated_at: null,
    },
    {
      name: '赠送积分比例',
      code: 'integral_rate',
      type: 'decimal',
      value: '1',
      parent_id: 35,
      id: 37,
      created_at: null,
      updated_at: null,
    },
    {
      name: '默认头像',
      code: 'default_avatar',
      type: 'image',
      value: '',
      parent_id: 1,
      id: 38,
      created_at: null,
      updated_at: null,
    },
    {
      name: '签到设置',
      code: 'sign',
      type: 'input',
      value: '',
      parent_id: 0,
      id: 39,
      created_at: '2020-01-02T03:47:34.000Z',
      updated_at: '2020-01-02T03:47:34.000Z',
    },
    {
      name: '签到积分',
      code: 'sign_integral',
      type: 'decimal',
      value: '10',
      parent_id: 39,
      id: 40,
      created_at: '2020-01-02T03:48:14.000Z',
      updated_at: '2020-01-02T03:48:14.000Z',
    },
    {
      name: '签到赠送积分开启',
      code: 'sign_avaiable',
      type: 'switch',
      value: '1',
      parent_id: 39,
      id: 41,
      created_at: '2020-01-02T08:28:20.000Z',
      updated_at: '2020-01-02T08:28:20.000Z',
    },
  ];
  const result = list.map(item => ({
    ...item,
    value: `${item.value}`,
  })).map(filterNoNeed);
  for (let i = 0; i < result.length; i++) {
    await app.model.setting.upsert(result[i]);
  }

  return true;
};


exports.language = async (app) => {
  const lang = [
    {
      name: '中文',
      key: 'cn',
      id: 1,
      created_at: '2019-11-01T14:39:40.000Z',
      updated_at: '2019-11-01T14:39:40.000Z',
    },
    {
      name: '英语',
      key: 'en',
      id: 2,
      created_at: '2019-11-02T02:41:29.000Z',
      updated_at: '2019-11-02T02:41:29.000Z',
    },
  ].map(filterNoNeed);
  const language = [
    {
      name: '你好',
      lang_id: 1,
      key: 'hello',
      value: '你好',
      id: 1,
      created_at: '2019-11-01T14:41:24.000Z',
      updated_at: '2019-11-01T14:41:24.000Z',
    },
    {
      name: '你好',
      lang_id: 2,
      key: 'hello',
      value: 'hello',
      id: 2,
      created_at: '2019-11-02T02:41:42.000Z',
      updated_at: '2019-11-02T02:41:42.000Z',
    },
    {
      name: '登录',
      lang_id: 1,
      key: 'login',
      value: '登录',
      id: 3,
      created_at: '2019-11-03T09:05:44.000Z',
      updated_at: '2019-11-03T09:05:44.000Z',
    },
    {
      name: '登录',
      lang_id: 2,
      key: 'login',
      value: 'login',
      id: 4,
      created_at: '2019-11-03T09:05:55.000Z',
      updated_at: '2019-11-03T09:05:55.000Z',
    },
    {
      name: '登出',
      lang_id: 1,
      key: 'logout',
      value: '登出',
      id: 5,
      created_at: '2019-11-03T09:06:16.000Z',
      updated_at: '2019-11-03T09:06:16.000Z',
    },
    {
      name: '登出',
      lang_id: 2,
      key: 'logout',
      value: 'logout',
      id: 6,
      created_at: '2019-11-03T09:06:31.000Z',
      updated_at: '2019-11-03T09:06:31.000Z',
    },
    {
      name: '注册',
      lang_id: 1,
      key: 'register',
      value: '注册',
      id: 7,
      created_at: '2019-11-03T09:07:56.000Z',
      updated_at: '2019-11-03T09:07:56.000Z',
    },
    {
      name: '注册',
      lang_id: 2,
      key: 'register',
      value: 'register',
      id: 8,
      created_at: '2019-11-03T09:08:06.000Z',
      updated_at: '2019-11-03T09:08:06.000Z',
    },
    {
      name: '我的订单',
      lang_id: 1,
      key: 'my_order',
      value: '我的订单',
      id: 9,
      created_at: '2019-11-03T09:44:56.000Z',
      updated_at: '2019-11-03T09:44:56.000Z',
    },
    {
      name: '我的订单',
      lang_id: 2,
      key: 'my_order',
      value: 'my order',
      id: 10,
      created_at: '2019-11-03T09:45:13.000Z',
      updated_at: '2019-11-03T09:45:13.000Z',
    },
    {
      name: '个人中心',
      lang_id: 1,
      key: 'person_center',
      value: '个人中心',
      id: 11,
      created_at: '2019-11-03T09:46:13.000Z',
      updated_at: '2019-11-03T09:46:13.000Z',
    },
    {
      name: '个人中心',
      lang_id: 2,
      key: 'person_center',
      value: 'person center',
      id: 12,
      created_at: '2019-11-03T09:46:37.000Z',
      updated_at: '2019-11-03T09:46:37.000Z',
    },
    {
      name: '购物车',
      lang_id: 1,
      key: 'person_cart',
      value: '购物车',
      id: 13,
      created_at: '2019-11-03T10:04:48.000Z',
      updated_at: '2019-11-03T10:04:48.000Z',
    },
    {
      name: '购物车',
      lang_id: 2,
      key: 'person_cart',
      value: 'cart',
      id: 14,
      created_at: '2019-11-03T10:05:10.000Z',
      updated_at: '2019-11-03T10:05:10.000Z',
    },
  ].map(filterNoNeed);
  for (let i = 0; i < lang.length; i++) {
    await app.model.lang.upsert(lang[i]);
  }
  for (let i = 0; i < language.length; i++) {
    await app.model.language.upsert(language[i]);
  }
  return true;
};


exports.orderStatus = async (app) => {
  const order_status = [
    {
      name: '待付款',
      intro: '提交订单',
      id: 1,
      created_at: '2019-11-16T03:49:38.000Z',
      updated_at: '2019-11-16T03:49:38.000Z',
    },
    {
      name: '待发货',
      intro: '付款成功',
      id: 2,
      created_at: '2019-11-16T03:49:38.000Z',
      updated_at: '2019-11-16T03:49:38.000Z',
    },
    {
      name: '待收货',
      intro: '商品出库',
      id: 3,
      created_at: '2019-11-16T03:49:38.000Z',
      updated_at: '2019-11-16T03:49:38.000Z',
    },
    {
      name: '已完成',
      intro: '完成',
      id: 4,
      created_at: '2019-11-16T03:49:38.000Z',
      updated_at: '2019-11-16T03:49:38.000Z',
    },
  ].map(filterNoNeed);


  for (let i = 0; i < order_status.length; i++) {
    await app.model.order_status.upsert(order_status[i]);
  }
};
