const { lodash } = require('multiple-quick-koa')

exports.getSetting = (config) => (type) =>
  config.find((i) => i.key === type).value

exports.getName = (config) => (type) => {
  const obj = config.find((i) => i.code === type)
  return lodash.get(obj, 'type', '')
}

exports.getList = (config) => (type) => {
  const obj = config.find((i) => i.code === type)
  if (!obj) throw new Error(`找不到${type}相关设置`)
  const list = config.filter((i) => i.parent_id === obj.id)
  return list
}

exports.getObject = (config) => (type) => {
  const obj = config.find((i) => i.code === type)
  if (!obj) throw new Error(`找不到${type}相关设置`)
  const list = config.filter((i) => i.parent_id === obj.id)
  const temObj = {}
  for (let i = 0; i < list.length; i++) {
    if (list[i].type === 'decimal') {
      temObj[list[i].code] = Number(list[i].value)
    } else if (list[i].type === 'switch') {
      temObj[list[i].code] = Boolean(Number(list[i].value))
    } else {
      temObj[list[i].code] = list[i].value
    }
  }
  return temObj
}

exports.hashFn = (str, asString = false, seed = false) => {
  var i
  var l

  var hval = seed === undefined ? 0x811c9dc5 : seed

  for (i = 0, l = str.length; i < l; i++) {
    hval ^= str.charCodeAt(i)

    hval += (hval << 1) + (hval << 4) + (hval << 7) + (hval << 8) + (hval << 24)
  }

  if (asString) {
    // Convert to 8 digit hex string

    return ('0000000' + (hval >>> 0).toString(16)).substr(-8)
  }

  return hval >>> 0
}

exports.safeSplit = (mainStr, str) => {
  if (mainStr.includes(str)) {
    return mainStr.split(str)
  }
  return ['', '']
}
