const { default: Schema } = require('async-validator');

module.exports = class Validator {
  constructor(descriptor) {
    this.validator = new Schema(descriptor);
  }

  async validate(data) {
    try {
      return await this.validator.validate(data);
    } catch (e) {
      throw new Error(e.errors.map(item => `${item.field}:${item.message}`));
    }
  }
};
